#ifndef distribution_include_declared
#define distribution_include_declared

#include "inclusive.h"
#include "RandomNumber.h"

class Distribution{
 private:
  bool _normalized;
  vector<double> *_dist;
  RandomNumber _rn;
  bool _Normalize();

 public:
  // constructors
  Distribution(int length, float *pArray);
  Distribution(int length, int *pArray);
  Distribution(int length, double *pArray);
  Distribution(vector<float> *pArray);
  Distribution(vector<double> *pArray);
  Distribution(vector<int> *pArray);
  Distribution(ScoreVector *pArray, int start, int length); //

  // destructor
  ~Distribution();

  // inspectors
  int TakeSample();
  int SelectMax();
  bool IsNormalized(){ return _normalized; };
  int Size(){return (int)_dist->size();}; //
  double GetValue(int i); //
  ScoreVector * GetVector(){return _dist;}; //

  // adaptors
  Distribution *ApplyMask(int start, int length);
  void SetValue(int i, double value); //
  
};

#endif
