#ifndef instancemap_include_declared
#define instancemap_include_declared

#include "Instance.h"
#include <algorithm> // 

typedef list<Instance*> InstanceList;
typedef list<Instance*>::iterator InstanceIterator; 

class InstanceMap {
 protected:
  int _numberOfInstances;
  int _iterCounter;
  InstanceList *_pInstanceList;
  InstanceIterator ii; //
  // for phylo motif detection (fixed width !)
  int *_pW; //
  StringVector*** _pInstanceCounts; //
  StringVector::iterator specIter;
  
 public:
  // constructor
  InstanceMap();
  InstanceMap(int *pW); // phylo 

  // destructor
  ~InstanceMap(); //
  
  // inspectors
  int NumberOfInstances(){return _numberOfInstances;};
  list<Instance *>::iterator begin(){return _pInstanceList->begin();};
  list<Instance *>::iterator end(){return _pInstanceList->end();};
  int NbrInstList(){return (int)_pInstanceList->size();}
  int ** GetIntegerCounts(); // returns new matrix 
  int * GetMotifWidth(){ return _pW;}; // nodig ?

  // adaptors
  InstanceMap * AddInstance(Instance *pInst); //
  void AddInstances(InstanceList *pList); // nodig ?
  InstanceMap * RemoveInstance(Instance *pInst); //
  InstanceMap * ReplaceInstance(Instance *oldInst, Instance *newInst); //
  InstanceMap * RemoveInstanceFromSequence(SequenceObject *pSeq); //
  InstanceMap * RemoveInstanceFromSequence(string * id); ////
  InstanceMap * Erase(list<Instance *>::iterator iter); // nodig ?
  void ClearMap(); //

  // phylo 
  void AddInstanceToCounts(Instance * pInst); 
  void RemoveInstanceFromCounts(Instance * pInst); 
  StringVector*** GetInstanceCounts(){return _pInstanceCounts;}; 

};

#endif
