#ifndef northogeneobject_include_declared
#define northogeneobject_include_declared

// define as an inherited class
#include "GeneObject.h"
#include "northoSequenceComputation.h" 

class NOrthoGeneObject : public GeneObject
{
 private:
  // all variables can be used from GeneObject
  // specific for NOrthoGeneObject
  MatrixMap * _pPriorEvolMatrices;
  InstanceMap * _pNodeInstances;
  InstanceIterator instIter; 
  int _priorScale;
 
 public:

  // constructor
  NOrthoGeneObject(const bool &bMinus);
  // destructor
  ~NOrthoGeneObject();

  // input 
  void InitializeInstanceTools()
  { _pSpeciesInstances = new InstanceMap(); _pNodeInstances = new InstanceMap(); return;};
  void InitializeComputationTools(SpeciesMap * spMap);
  void ComputePriorCounts(SpeciesMap * spMap, const double &slowrate, const int &priorscale);

  // motif detection
  void InitNodeInstanceMap(SpeciesMap * spMap);
  PWM * BuildEvolutionProbs(double*** pReducedCounts, double ** pPriorCounts, Sequence * pSite, bool bknownParent);
  void StoreEvolPWM(string * id_end, const bool &bSpecies_end, string * daughterid, double*** pRedCounts, vector<PWM*> * pPWMs, vector<double>* pPSPs);
  void UpdateScoresStep(SeqIterator Iter, PWM * pMotifModel);

  // motif manipulation
  void SetSpeciesInstances(InstanceMap * map){if (_pSpeciesInstances != NULL) delete _pSpeciesInstances; _pSpeciesInstances = map;};

  // inspectors
  InstanceMap * GetNodeInstances(){return _pNodeInstances;};

};

#endif
