#ifndef northosamplerrun_include_declared
#define northosamplerrun_include_declared

// define as an inherited class
#include "SamplerRun.h"
#include "NOrthoGeneObject.h"
#include "inclusive.h"

class NOrthoSamplerRun: public SamplerRun
{

 private:
  // all variables can be used from SamplerRun
  // specific for NOrthoSamplerRun 

 public:
  // constructor : this constructor calls the SamplerRun constructor
  NOrthoSamplerRun();
  // destructor
  ~NOrthoSamplerRun();

  // input 
  GeneObject * AddGene(string * gene);
  void InitializeLocalVariables2(const double &slowrate, const int &priorscale);
  // motif detection
  void InitInstanceMap();
  void DetectionStep(const string &step, const int &nbrIter);
  // motif manipulation
  PWM * BuildReducedRootMotif(string gene);
  double*** CountReducedEvolution(string gene, string * id, string * id2, bool bSpecies);
  // motif result
  void PrintNodeInstances(GFFWriter * gff);
};


#endif
