#ifndef phylogeneobject_include_declared
#define phylogeneobject_include_declared

// define as an inherited class
#include "GeneObject.h"
#include "phyloSequenceComputation.h"

class PhyloGeneObject : public GeneObject
{
 private:
  // all variables can be used from GeneObject
  // specific for PhyloGeneObject
  double **_pNtWeights;
  double **** _pInfo; 
  double _dY;
  list<double*> *_pACGTsamples;
  list<double*>::iterator ACGTiter;
  bool _phylo_2;

 public:
  // constructor : this constructor calls the GeneObject constructor
  PhyloGeneObject(const bool &bMinus);
  // destructor
  ~PhyloGeneObject();

  // input
  void InitializeInstanceTools();
  void InitializeComputationTools(SpeciesMap * spMap, const double &y, const double &z, const bool &phylo2);

  // motif detection
  void UpdateScoresStep(SeqIterator Iter, double** redgen);
  double** ComputeReducedInstMutProb(Matrix redPWM);
  double ComputeReducedInstBackground();
  void UpdateNtWeights();
  double** GetNtWeights(){return _pNtWeights;};
  void UpdateProxPSPinLocalpInfoVariable();
  void ComputeConservedWeight(int W, int NT);
  double ComputeNonConservedWeight(int W);

};

#endif
