#ifndef phylosamplerrun_include_declared
#define phylosamplerrun_include_declared

// define as an inherited class
#include "SamplerRun.h"
#include "PhyloGeneObject.h"
#include "inclusive.h"

class PhyloSamplerRun : public SamplerRun
{

 private:
  // all variables can be used from SamplerRun
  // specific for PhyloSamplerRun  

 public:
  // constructor : this constructor calls the SamplerRun constructor
  PhyloSamplerRun();
  // destructor
  ~PhyloSamplerRun();

  // input 
  GeneObject * AddGene(string * gene);
  void InitializeLocalVariables2(const double &dY, const double &dZ, const bool &phylo2);
  // motif detection
  void InitInstanceMap();
  void DetectionStep(const string &step, const int &nbrIter);
  // motif manipulation
  double ** BuildReducedCounts(GeneMapIterator iter); 
  double ** BuildReducedGen(GeneMapIterator iter); 
  double ** BuildConvergenceGen(GeneMapIterator iter);
 
};


#endif
