#ifndef speciesmap_include_declared
#define speciesmap_include_declared

#include "BackgroundIO.h"
#include "phylutilities.h"

typedef struct{BackgroundModel * pBgM;
               double * pSNF;
               vector<Distribution*> * pNbrInstDistr;
               vector<string> * pRelations;
              } speciesgeg; 

class SpeciesMap{

 private:
  // store variables
  map<string, speciesgeg> * _pMap;
  map<string, speciesgeg>::iterator iter; 
  int _nbrSpecies;
  int _nbrNodes;
  // other

 public:

  // constructor
  SpeciesMap();
  
  // destructor
  ~SpeciesMap();

  // adaptors
  void AddSpecies(string *pSpecies, bool species);
  void AddRelation( string parent, string daughter);
  int StoreBgModel(string * input);
  void StoreMaxPriorInput(const int &Max, string Input);
  int StoreMaxPriorInput(const int &max, string pdefault, string * input);
  void SetNodeSNF(string id, double * snf){ (*_pMap)[id].pSNF = snf; return;}
  
  // inspector
  int NbrSpecies(){return _nbrSpecies;};
  int NbrNodes(){return _nbrNodes;};
  map<string, speciesgeg> * GetMap(){return _pMap;};
  StringVector * GetSpeciesDaughters(const int nodeNbr);

  // other
  double * ComputeDatasetSnf();
 
};


#endif
