#ifndef phylofastaio_include_declared
#define phylofastaio_include_declared

#include "exceptions.h"
#include "SequenceObject.h"

class phyloFastaIO { 

 private:
  ifstream _ifs;
  string _pLine;
  // line properties
  bool _hasGene; // >>
  bool _hasNext; // >
  bool _has; // contents

 public:
  phyloFastaIO(string *fastafile); // start on >>
  phyloFastaIO(string *borcfile, string dummy); // start on >
  ~phyloFastaIO(){if (_ifs.good()) _ifs.close();}; // close file
  
  // inspectors
  bool HasGene(){return _hasGene;}; 
  bool HasNext(){return _hasNext;}; 
  bool Has(){return _has;};
  bool NotEmpty(){ return (_hasGene || _hasNext || _has);};

  // adaptors 
  SequenceObject * ReadSequence(const strand_modes &s); // >speciesid and code
  string * ReadGene(); //  (>>)
  string * ReadNext(); //  (>)
  void ProceedCursor(); // set cursor on next line
  string * ReadSeqID(); // (>id)
  ScoreVector * LoadPspData(int seqL, int wL);
};

#endif
