#include "northoSequenceComputation.h"

using namespace INCLUSIVE;

/******************************************************************************
  Description:  constructor 
  Author_Date:  MC_2014/02/15
******************************************************************************/
northoSequenceComputation::northoSequenceComputation(const strand_modes s, 
SequenceObject *pSeqObj, int *w, double &prox, vector<Distribution*> * dists):
dualSequenceComputation(s, pSeqObj, w, prox, dists)
{
  //cerr << "Debug-northoSequenceComputation::constructor -begin" << endl;
  //cerr << "Debug-northoSequenceComputation::constructor -end" << endl;
}
/******************************************************************************
  Description:  destructor 
  Author_Date:  MC_2014/02/15
******************************************************************************/
northoSequenceComputation::~northoSequenceComputation()
{
  //cerr << "destructor-northoSequenceComputation -begin" << endl;
  //cerr << "destructor northoSequenceComputation -end" << endl;
}

/******************************************************************************
  Description:  Update the motif scores for all segments in this sequence
  Author_Date:  MC_2013/12/30 (no direct psp impact here )
******************************************************************************/
void
northoSequenceComputation::UpdateSegmentScores(PWM * pEvolPWM)
{
//cerr << "--debug::northoSequenceComputation::UpdateSegmentScores-begin" << endl;
  SegmentLogMatrixScore(_pMotifScore, _pSeqObj, _strand, pEvolPWM);
  // define some iterators
  vector < double >::iterator iter1;
  vector < double >::iterator iter2;
  vector < double >::iterator iter3;
  vector < int >::iterator iter4;

  iter1 = _pMotifScore->begin();
  iter2 = _pSegmentBgScore->begin();
  iter3 = _pExpWx->begin(); // to be updated below
  iter4 = _pMask->begin();
  while (iter1 != _pMotifScore->end())
  {
    (*iter3) = exp((*iter1) - (*iter2)) * (*iter4);
// if ( (*iter3)> 0.0003) cerr <<  (*iter3) << " ";
    // augment iterators
    iter1++;
    iter2++;
    iter3++;
    iter4++;
  }
//cerr << "--debug::northoSequenceComputation::UpdateSegmentScores-end" << endl;
  return;
}
